Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 3423)
@@ -230,7 +230,8 @@
         T item = itemsListView.SelectedItems[0].Tag as T;
         if (item != null) {
-          IView view = MainFormManager.CreateDefaultView(item);
+          IContentView view = MainFormManager.CreateDefaultView(item);
           if (view != null) {
             view.ReadOnly = ReadOnly;
+            view.Locked = Locked;
             view.Show();
           }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3423)
@@ -190,7 +190,8 @@
       if (itemsListView.SelectedItems.Count == 1) {
         T item = (T)itemsListView.SelectedItems[0].Tag;
-        IView view = MainFormManager.CreateDefaultView(item);
+        IContentView view = MainFormManager.CreateDefaultView(item);
         if (view != null) {
-          view.ReadOnly = this.ReadOnly;
+          view.ReadOnly = ReadOnly;
+          view.Locked = Locked;
           view.Show();
         }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 3423)
@@ -224,7 +224,8 @@
       if (itemsListView.SelectedItems.Count == 1) {
         T item = (T)itemsListView.SelectedItems[0].Tag;
-        IView view = MainFormManager.CreateDefaultView(item);
+        IContentView view = MainFormManager.CreateDefaultView(item);
         if (view != null) {
           view.ReadOnly = ReadOnly;
+          view.Locked = Locked;
           view.Show();
         }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/OperatorTreeView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/OperatorTreeView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/OperatorTreeView.cs	(revision 3423)
@@ -355,7 +355,8 @@
         IOperator op = GetOperatorTag(graphTreeView.SelectedNode);
         if (op != null) {
-          IView view = MainFormManager.CreateDefaultView(op);
+          IContentView view = MainFormManager.CreateDefaultView(op);
           if (view != null) {
             view.ReadOnly = this.ReadOnly;
+            view.Locked = this.Locked;
             viewToolStripMenuItem.Enabled = true;
             viewToolStripMenuItem.Tag = view;
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs	(revision 3423)
@@ -156,5 +156,10 @@
           if (shapeInfo != null) {
             IOperator op = this.VisualizationInfo.GetOperatorForShapeInfo(shapeInfo);
-            MainFormManager.CreateDefaultView(op).Show();
+            IContentView view = MainFormManager.CreateDefaultView(op);
+            if (view != null) {
+              view.ReadOnly = this.ReadOnly;
+              view.Locked = this.Locked;
+              view.Show();
+            }
             HandledMouseEventArgs eventArgs = e as HandledMouseEventArgs;
             if (eventArgs != null)
@@ -189,5 +194,8 @@
       if (shapeInfo != null) {
         IOperator op = this.VisualizationInfo.GetOperatorForShapeInfo(shapeInfo);
-        MainFormManager.CreateDefaultView(op).Show();
+        IContentView view = MainFormManager.CreateDefaultView(op);
+        view.ReadOnly = this.ReadOnly;
+        view.Locked = this.Locked;
+        view.Show();
       }
     }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/EngineAlgorithmView.cs	(revision 3423)
@@ -158,5 +158,10 @@
 
     protected virtual void createUserDefinedAlgorithmButton_Click(object sender, EventArgs e) {
-      MainFormManager.CreateDefaultView(Content.CreateUserDefinedAlgorithm()).Show();
+      IContentView view = MainFormManager.CreateDefaultView(Content.CreateUserDefinedAlgorithm());
+      if (view != null) {
+        view.ReadOnly = this.ReadOnly;
+        view.Locked = this.Locked;
+        view.Show();
+      }
     }
   }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionTabularView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionTabularView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionTabularView.cs	(revision 3423)
@@ -54,11 +54,17 @@
 
     public new RunCollection Content {
-      get { return (RunCollection) base.Content; }
+      get { return (RunCollection)base.Content; }
       set { base.Content = value; }
     }
 
     private void dataGridView_RowHeaderMouseDoubleClick(object sender, DataGridViewCellMouseEventArgs e) {
-      if (e.RowIndex > 0)
-        MainFormManager.CreateDefaultView(Content.ElementAt(e.RowIndex)).Show();
+      if (e.RowIndex > 0) {
+        IContentView view = MainFormManager.CreateDefaultView(Content.ElementAt(e.RowIndex));
+        if (view != null) {
+          view.ReadOnly = this.ReadOnly;
+          view.Locked = this.Locked;
+          view.Show();
+        }
+      }
     }
   }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionView.cs	(revision 3423)
@@ -166,7 +166,8 @@
       if (itemsListView.SelectedItems.Count == 1) {
         IRun item = (IRun)itemsListView.SelectedItems[0].Tag;
-        IView view = MainFormManager.CreateDefaultView(item);
+        IContentView view = MainFormManager.CreateDefaultView(item);
         if (view != null) {
           view.ReadOnly = ReadOnly;
+          view.Locked = Locked;
           view.Show();
         }
Index: trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs
===================================================================
--- trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 3422)
+++ trunk/sources/HeuristicLab.Optimization.Views/3.3/RunView.cs	(revision 3423)
@@ -128,7 +128,8 @@
       if (listView.SelectedItems.Count == 1) {
         IItem item = (IItem)listView.SelectedItems[0].Tag;
-        IView view = MainFormManager.CreateDefaultView(item);
+        IContentView view = MainFormManager.CreateDefaultView(item);
         if (view != null) {
           view.ReadOnly = ReadOnly;
+          view.Locked = Locked;
           view.Show();
         }
@@ -147,4 +148,5 @@
       if (view != null) {
         view.ReadOnly = ReadOnly;
+        view.Locked = Locked;
         view.Show();
       }