Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs	(revision 3439)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionBubbleChartView.Designer.cs	(revision 3440)
@@ -24,6 +24,6 @@
     /// </summary>
     private void InitializeComponent() {
-      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea1 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
-      System.Windows.Forms.DataVisualization.Charting.Series series1 = new System.Windows.Forms.DataVisualization.Charting.Series();
+      System.Windows.Forms.DataVisualization.Charting.ChartArea chartArea2 = new System.Windows.Forms.DataVisualization.Charting.ChartArea();
+      System.Windows.Forms.DataVisualization.Charting.Series series2 = new System.Windows.Forms.DataVisualization.Charting.Series();
       this.yJitterLabel = new System.Windows.Forms.Label();
       this.xJitterlabel = new System.Windows.Forms.Label();
@@ -51,5 +51,4 @@
       // 
       this.yJitterLabel.AutoSize = true;
-      this.yJitterLabel.BackColor = System.Drawing.SystemColors.Control;
       this.yJitterLabel.Location = new System.Drawing.Point(257, 6);
       this.yJitterLabel.Name = "yJitterLabel";
@@ -62,5 +61,4 @@
       this.xJitterlabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.xJitterlabel.AutoSize = true;
-      this.xJitterlabel.BackColor = System.Drawing.SystemColors.Control;
       this.xJitterlabel.Location = new System.Drawing.Point(461, 309);
       this.xJitterlabel.Name = "xJitterlabel";
@@ -72,5 +70,4 @@
       // 
       this.xTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.xTrackBar.BackColor = System.Drawing.SystemColors.Control;
       this.xTrackBar.Location = new System.Drawing.Point(496, 306);
       this.xTrackBar.Maximum = 100;
@@ -85,5 +82,4 @@
       this.xAxisLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.xAxisLabel.AutoSize = true;
-      this.xAxisLabel.BackColor = System.Drawing.SystemColors.Control;
       this.xAxisLabel.Location = new System.Drawing.Point(213, 309);
       this.xAxisLabel.Name = "xAxisLabel";
@@ -107,5 +103,4 @@
       // 
       this.yAxisLabel.AutoSize = true;
-      this.yAxisLabel.BackColor = System.Drawing.SystemColors.Control;
       this.yAxisLabel.Location = new System.Drawing.Point(3, 6);
       this.yAxisLabel.Name = "yAxisLabel";
@@ -127,5 +122,4 @@
       // yTrackBar
       // 
-      this.yTrackBar.BackColor = System.Drawing.SystemColors.Control;
       this.yTrackBar.Location = new System.Drawing.Point(292, 3);
       this.yTrackBar.Maximum = 100;
@@ -152,5 +146,4 @@
       this.sizeLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.sizeLabel.AutoSize = true;
-      this.sizeLabel.BackColor = System.Drawing.SystemColors.Control;
       this.sizeLabel.Location = new System.Drawing.Point(371, 6);
       this.sizeLabel.Name = "sizeLabel";
@@ -164,16 +157,16 @@
                   | System.Windows.Forms.AnchorStyles.Left)
                   | System.Windows.Forms.AnchorStyles.Right)));
-      chartArea1.Name = "ChartArea1";
-      this.chart.ChartAreas.Add(chartArea1);
+      chartArea2.Name = "ChartArea1";
+      this.chart.ChartAreas.Add(chartArea2);
       this.chart.Location = new System.Drawing.Point(6, 30);
       this.chart.Name = "chart";
-      series1.ChartArea = "ChartArea1";
-      series1.ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Bubble;
-      series1.CustomProperties = "BubbleMaxSize=0";
-      series1.IsVisibleInLegend = false;
-      series1.MarkerStyle = System.Windows.Forms.DataVisualization.Charting.MarkerStyle.Circle;
-      series1.Name = "Bubbles";
-      series1.YValuesPerPoint = 2;
-      this.chart.Series.Add(series1);
+      series2.ChartArea = "ChartArea1";
+      series2.ChartType = System.Windows.Forms.DataVisualization.Charting.SeriesChartType.Bubble;
+      series2.CustomProperties = "BubbleMaxSize=0";
+      series2.IsVisibleInLegend = false;
+      series2.MarkerStyle = System.Windows.Forms.DataVisualization.Charting.MarkerStyle.Circle;
+      series2.Name = "Bubbles";
+      series2.YValuesPerPoint = 2;
+      this.chart.Series.Add(series2);
       this.chart.Size = new System.Drawing.Size(556, 263);
       this.chart.TabIndex = 16;